function f=corana(x)
% f=CORANA(x): Multi-dimensional Corana paraboloid with holes. 
% Test problem for minimization.
% 
% Global minimum of zero everywhere in [-0.05,0.05]^K
% x is KxM matrix, each column is one parameter vector input.
% f is 1xM output vector.
%
% Note: Standard representation uses 10^(i-1) as weight for dimension i.
%       This version uses less extreme weight of exp(i-1).
% Michael Gordy <mgordy@frb.gov> 22 October 1997

[K,M]=size(x);
z=0.2*round(abs(x/0.2)).*sign(x);
g=0.15*((z-0.05*sign(z)).^2);
A=abs(x-z)<0.05;
w=exp(0:K-1);
f=w*(A.*g+(1-A).*(x.^2));
