function S1 = filldefaultfields(S,S0)
%FILLDEFAULTFIELDS(S,S0)  Fill in missing fields from S using S0
%
% S1 = filldefaultfields(S,S0)
%   Creates new structured variable S1 containing all fields in S0.
%   If S has a field by the same name, use that value.
%   Otherwise, use default value in S0.
%   Fields in S that do not exist in S0 are ignored.

S1 = S0;
snames = fieldnames(S);
for i=1:length(snames)
  if isfield(S0,snames{i})
     S1 = setfield(S1,snames{i},getfield(S,snames{i}));
  end
end
